import java.util.ArrayList;
import java.util.Random;
import java.util.Scanner;


public class PlayerRandom {
  public static void main(String args[]) {
    Scanner in = new Scanner(System.in);
    Random rng = new Random(666);
    double changedir = 0.3;
    Vision vis = new Vision();
    vis.init(in);
    String lastDir = "X";

    // game loop
    while (true) {
      vis.read(in);

      System.err.println(String.format("%s", vis.dirs));
      if (vis.dirs.size()==1) {System.out.println(vis.dirs.get(0)); lastDir = vis.dirs.get(0); continue;}
      if (rng.nextDouble()<changedir) {vis.dirs.remove(Vision.REVDIR(lastDir)); lastDir = vis.dirs.get(rng.nextInt(vis.dirs.size())); System.out.println(lastDir); continue;}
      if (vis.dirs.contains(lastDir)) {System.out.println(lastDir); continue;}
      vis.dirs.remove(Vision.REVDIR(lastDir));
      lastDir = vis.dirs.get(rng.nextInt(vis.dirs.size()));
      System.out.println(lastDir);
    }
  }
}

class Vision
{
  public int visionRange;
  public ArrayList<String> dirs = new ArrayList<>();


  public void init(Scanner in) {
    visionRange = in.nextInt(); // Diameter of Lazzie's vision
    int homeDistanceHorizontal = in.nextInt(); // Distance in W/E direction towards home (negative means W side, positive means E side)
    int homeDistanceVertical = in.nextInt(); // Distance in N/S direction towards home (negative means N side, positive means S side)
  }

  public void read(Scanner in)
  {
    int radius = visionRange/2;
    dirs.clear();

    for (int dy = -radius; dy <= radius; dy++)
    {
      String row = in.next(); // A single row of the map within the vision range. Possible tile values: passable terrain ('.'), impassable obstacles ('#'), outside vision circle ('?'), home entrance ('H'), Lazzie ('L').
      //System.err.println(String.format("%s", row));
      for (int dx = -radius; dx <= radius; dx++)
      {
        char c = row.charAt(dx+radius);
        if (c!='#' &&dx==0&&dy==-1) dirs.add("N");
        if (c!='#' &&dx==0&&dy==1) dirs.add("S");
        if (c!='#' &&dx==1&&dy==0) dirs.add("E");
        if (c!='#' &&dx==-1&&dy==0) dirs.add("W");
      }
    }
  }

  public static String REVDIR(String dir) {
    switch (dir)
    {
      case "N": return "S";
      case "S": return "N";
      case "W": return "E";
      case "E": return "W";
      default: return "X";
    }
  }
}



